/* CS 472/672 Assignment #2 - mindeg.c file */

#include "colamd.h"
#include <stdio.h>
#include <assert.h>


int mindeg            /* return (1) if OK, (0) otherwise */
(
    int* ia,          /* row pointers of A */
    int* ja ,         /* col indices of A */
    int n,            /* number of rows and columns of A */
    int* order        /* output permutation, size n */
)
{
   int     stats [COLAMD_STATS]; /* output statistics and error codes */
   double* knobs;
   int     *perm, test, i;


   knobs = NULL;  /* use default params */

   perm = (int *) calloc(n+1,sizeof(int));
   assert(perm != NULL);
   /* note this has to be of size n+1 */

   test = symamd (n, ja, ia, perm, knobs,  stats , calloc, free);
 
   if (test == 0) {
      symamd_report(stats);
   }
   assert( test != 0);
  
   for (i=0; i<n; i++) {
     order[i] = perm[i];
   }

   free (perm);

   return(test);
}

